"""
CoRNy Config
    Deal with Configuration files
"""

from corny import *

def read_config(file, chdir=False):
    # Config
    config = configparser.ConfigParser()
    if file is None: file = 'config.cfg'
    if not os.path.isfile(file):
        print(cprintf('! Config file required! Either specify it as an argument or provide ./config.cfg', 'red'))
        return()
    else:
        print("i Working with %s" % file)

    temp = config.read(file)

    if chdir:
        # Change to this directory
        config_dir, config_file_name = os.path.split(file)
        os.chdir(os.path.normpath(config_dir))

    # clean config
    if os.path.isdir(config['input']['path']):
        # add trailing slash
        config['input']['path'] = os.path.join(config['input']['path'], '')
    # check whether output path exists
    if config['output']['out_path']:
        if not os.path.exists(config['output']['out_path']):
            os.makedirs(config['output']['out_path'])
    # add trailing slash
    config['output']['out_path'] = os.path.join(config['output']['out_path'], '')

    return(config)

def check_config(config, section, key, value=None):
    # return False if item does not exist or is empty
    r = False
    if section in config:
        if key in config[section]:
            if value is None:
                if config[section][key].strip() != '':
                    r = True
            elif config[section][key] == value:
                r = True
    return(r)

cc = check_config

def get_config(config, section, key, alt=None, dtype=None):
    # return None if item does not exist or is empty
    r = alt
    if section in config:
        if key in config[section]:
            if not config[section][key].isspace():
                r = config[section][key]
    if dtype==float and not r is None:
        r = float(r)
    return(r)

gc = get_config

def yesno2bool(s):
    s = s.lower()
    if s == 'yes' or s == 'y':
        return(True)
    else:
        return(False)
