"""
CoRNy exdata.NM
    Get Data from NMDB
"""

from corny import *


import rasterio
#pandas.options.mode.chained_assignment = None  # Skip annoying warnings

def get_from_raster(data, var, file):

    if var == 'bd':
        def function(x): return(float(x)/1000)
    elif var == 'clay':
        def function(x): return(float(x)/100)
    elif var == 'org':
        def function(x): return(float(x)/1000)
    elif var == 'luse':
        def function(x): return(int(x))
    else:
        def function(x): return(float(x))

    with rasterio.open(file) as src:
        data[var] = [function(x) for x in src.sample(zip(data.lon, data.lat))]

    if var == 'luse':
        # TODO: this should be a variable with its properties and methods
        luse_cat = ['urban', 'agriculture', 'wetland', 'forest', 'water']
        luse_col = ['red', 'orange', 'lightblue', 'green', 'blue']    
        luse_corineid = [1,2,4,3,5]

        data['luse_str'] = np.nan
        for i in np.arange(len(luse_cat)):
            data.loc[data['luse'] // 100 == luse_corineid[i], 'luse_str'] = luse_cat[i]
    
    return(data)
